
/*
 *  Copyright (c) 2008-2013 Silicon Graphics, Inc.  All Rights Reserved.
 *  Copyright 2020 Hewlett Packard Enterprise Development LP
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#ifndef __GRU_KABI_HACK_H__
#define __GRU_KABI_HACK_H__
#include <linux/version.h>

/* Ugly error-prone kludge to avoid KABI breakage */
#include <asm/uv/uv_mmrs.h>
#include <asm/uv/uv_hub.h>

#define UVH_GR0_CE_CONFIG	(is_uv4_hub() ? 0x600000 : 0xc00000)
#define UVH_GR1_CE_CONFIG	(is_uv4_hub() ? 0x700000 : 0x1000000)

#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,8,0)) && !defined(SLES15SP3PLUS) && \
!defined(RHEL84PLUS)
#define mmap_read_lock(mm)	down_read(&(mm)->mmap_sem)
#define mmap_read_unlock(mm)	up_read(&(mm)->mmap_sem)
#define mmap_read_trylock(mm)	down_read_trylock(&(mm)->mmap_sem)
#endif
#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,8,0)) && !defined(SLES15SP3PLUS)
#define kthread_use_mm(mm)	use_mm(mm)
#define kthread_unuse_mm(mm)	unuse_mm(mm)
#endif

#endif		/* __GRU_KABI_HACK_H__ */
